#include "MPU6050.h"
#include "iic.h"
#include <math.h>
#include "stdio.h"


float Yaw=0.0,Pitch=0.0,Roll=0.0;  //ƫǣǣ
int16_t aacx,aacy,aacz;		//ٶȴԭʼ
int16_t gyrox,gyroy,gyroz;	//ԭʼ
float filteredYaw = 0.0, filteredPitch = 0.0, filteredRoll = 0.0;  // ˲̬
float alpha = 0.2;  // ˲Ȩ
float lastYaw = 0.0, lastPitch = 0.0, lastRoll = 0.0;  // һ˲

// ˲
float kalmanFilter(float z, float dt)
{
	// 忨˲
static float Q = 0.01;  // Э
static float R = 0.1;   // ۲Э

// 忨˲
static float x = 0;     // ״ֵ̬
static float P = 1;     // ״̬Э
    // Ԥⲽ
    float x_pred = x;
    float P_pred = P + Q;

    // ²
    float K = P_pred / (P_pred + R);
    x = x_pred + K * (z - x_pred);
    P = (1 - K) * P_pred;

    return x;
}

void Delay1ms(void)	//@35MHz
{
	unsigned long edata i;

	_nop_();
	_nop_();
	_nop_();
	i = 8748UL;
	while (i) i--;
}

void MPU_Delay_Ms(uint16_t Milliseconds)	//ֲʱ޸
{
	while(Milliseconds--)
		Delay1ms();
}

//IICд
//reg:ҪдļĴַ
//len:Ҫдĳ
//buf:Ҫдݵ׵ַ
//ֵ:0,
//    ,
uint8_t MPU_Write_Len(uint8_t reg, uint8_t len, uint8_t *buf)
{
	return i2c_mem_write(MPU_ADDR, reg, buf, len);
}

//IIC
//reg:ҪȡļĴַ
//len:Ҫȡĳ
//buf:ȡݴ洢
//ֵ:0,
//    ,
uint8_t MPU_Read_Len(uint8_t reg, uint8_t len, uint8_t *buf)
{
	return i2c_mem_read(MPU_ADDR, reg, buf, len);
}

//IICдһֽ 
//reg:Ĵַ
//Data:
//ֵ:0,
//    ,
uint8_t MPU_Write_Byte(uint8_t reg, uint8_t Data)
{
	return i2c_mem_write(MPU_ADDR, reg, &Data, 1);
}

//IICһֽ 
//reg:Ĵַ 
//ֵ:
uint8_t MPU_Read_Byte(uint8_t reg)
{
	uint8_t res;
	i2c_mem_read(MPU_ADDR, reg, &res, 1);
	return res;
}

//д8λĴһλ
uint8_t MPU_Write_Bit(uint8_t addr, uint8_t bitNum, uint8_t Data)
{
	return i2c_write_bit(MPU_ADDR, addr, bitNum, Data);
}

//д8λĴĶλ
uint8_t MPU_Write_Bits(uint8_t addr, uint8_t bitStart, uint8_t length, uint8_t Data)
{
	return i2c_write_bits(MPU_ADDR, addr, bitStart, length, Data);
}

//ȡһλ8λļĴ
uint8_t MPU_Read_Bit(uint8_t addr, uint8_t bitNum, uint8_t *Data)
{
	return i2c_read_bit(MPU_ADDR, addr, bitNum, Data);
}

//ȡ8λĴĶλ
uint8_t MPU_Read_Bits(uint8_t addr, uint8_t bitStart, uint8_t length, uint8_t *Data)
{
	return i2c_read_bits(MPU_ADDR, addr, bitStart, length, Data);
}
//ʼMPU6050
//ֵ:0,ɹ
//    ,
uint8_t MPU_Init(void)
{
	uint8_t res;
	MPU_Write_Byte(MPU_PWR_MGMT1_REG, 0X80);	//λMPU6050
	MPU_Delay_Ms(100);
	MPU_Write_Byte(MPU_PWR_MGMT1_REG, 0X00);	//MPU6050 
	MPU_Set_Gyro_Fsr(3);						//Ǵ,2000dps
	MPU_Set_Accel_Fsr(0);						//ٶȴ,2g
	MPU_Set_Rate(100);							//ò50Hz
	MPU_Write_Byte(MPU_INT_EN_REG, 0X01);		//ʹݾж
	MPU_Write_Byte(MPU_USER_CTRL_REG, 0X00);	//I2Cģʽر
	MPU_Write_Byte(MPU_FIFO_EN_REG, 0X00);		//رFIFO
	MPU_Write_Byte(MPU_INTBP_CFG_REG, 0X80);	//INTŵ͵ƽЧ
	res = MPU_Read_Byte(MPU_DEVICE_ID_REG);
	if (res == MPU_ADDR)//IDȷ
	{
		MPU_Write_Byte(MPU_PWR_MGMT1_REG, 0X01);	//CLKSEL,PLL XΪο
		MPU_Write_Byte(MPU_PWR_MGMT2_REG, 0X00);	//ٶǶ
		MPU_Set_Rate(200);							//òΪ200Hz
	}
	else
		return 1;
	return 0;
}

//MPU6050Ǵ̷Χ
//fsr:0,250dps;1,500dps;2,1000dps;3,2000dps
//ֵ:0,óɹ
//    ,ʧ 
uint8_t MPU_Set_Gyro_Fsr(uint8_t fsr)
{
	return MPU_Write_Byte(MPU_GYRO_CFG_REG, fsr << 3);//̷Χ  
}

//MPU6050ٶȴ̷Χ
//fsr:0,2g;1,4g;2,8g;3,16g
//ֵ:0,óɹ
//    ,ʧ 
uint8_t MPU_Set_Accel_Fsr(uint8_t fsr)
{
	return MPU_Write_Byte(MPU_ACCEL_CFG_REG, fsr << 3);//üٶȴ̷Χ  
}

//MPU6050ֵͨ˲
//lpf:ֵͨ˲Ƶ(Hz)
//ֵ:0,óɹ
//    ,ʧ 
uint8_t MPU_Set_LPF(uint16_t lpf)
{
	uint8_t Data = 0;
	if (lpf >= 188)Data = 1;
	else if (lpf >= 98)Data = 2;
	else if (lpf >= 42)Data = 3;
	else if (lpf >= 20)Data = 4;
	else if (lpf >= 10)Data = 5;
	else Data = 6;
	return MPU_Write_Byte(MPU_CFG_REG, Data);//ֵͨ˲  
}

//MPU6050Ĳ(ٶFs=1KHz)
//rate:4~1000(Hz)
//ֵ:0,óɹ
//    ,ʧ 
uint8_t MPU_Set_Rate(uint16_t rate)
{
	uint8_t Data;
	if (rate>1000)rate = 1000;
	if (rate<4)rate = 4;
	Data = 1000 / rate - 1;
	Data = MPU_Write_Byte(MPU_SAMPLE_RATE_REG, Data);	//ֵͨ˲
	return MPU_Set_LPF(rate / 2);	//ԶLPFΪʵһ
}

//õ¶ֵ
//ֵ:¶ֵ(100)
short MPU_Get_Temperature(void)
{
	uint8_t buf[2];
	short raw;
	float temp;
	MPU_Read_Len(MPU_TEMP_OUTH_REG, 2, buf);
	raw = ((uint16_t)buf[0] << 8) | buf[1];
	temp = 36.53 + ((double)raw) / 340;
	return temp * 100;;
}

// õֵ(ԭʼֵ)
// gx,gy,gz:x,y,zԭʼ()
// ֵ:0,ɹ
//    ,
uint8_t MPU_Get_Gyroscope(short *gx, short *gy, short *gz)
{
    uint8_t buf[6], res;
    res = MPU_Read_Len(MPU_GYRO_XOUTH_REG, 6, buf);
    if (res == 0)
    {
        *gx = ((uint16_t)buf[0] << 8) | buf[1];
        *gy = ((uint16_t)buf[2] << 8) | buf[3];
        *gz = ((uint16_t)buf[4] << 8) | buf[5];

        // Ӧһ˲˲
        filteredYaw = *gz;  // ʹݽ˲
        filteredPitch = *gy;

     
    }
    return res;
}

// õٶֵ(ԭʼֵ)
// ax,ay,az:ٶȼx,y,zԭʼ()
// ֵ:0,ɹ
//    ,
uint8_t MPU_Get_Accelerometer(short *ax, short *ay, short *az)
{
    uint8_t buf[6], res;
    res = MPU_Read_Len(MPU_ACCEL_XOUTH_REG, 6, buf);
    if (res == 0)
    {
        *ax = ((uint16_t)buf[0] << 8) | buf[1];
        *ay = ((uint16_t)buf[2] << 8) | buf[3];
        *az = ((uint16_t)buf[4] << 8) | buf[5];

        // Ӧһ˲˲
        filteredYaw = alpha * (*az) + (1 - alpha) * lastYaw;  // ʹüٶȼݽ˲
        filteredPitch = alpha * (*ax) + (1 - alpha) * lastPitch;
        filteredRoll = alpha * (*ay) + (1 - alpha) * lastRoll;

        // һ˲
        lastYaw = filteredYaw;
        lastPitch = filteredPitch;
        lastRoll = filteredRoll;
    }
    return res;
}
