#include <at24c02.H>
#define DIS_DOT     0x20
#define DIS_BLACK   0x10
#define DIS_        0x11
#define SLAW    0xA0
#define SLAR    0xA1
void AT24C02_Init()
{
	  I2C_S1 =0;   //I2Cܽѡ00:P1.5,P1.4; 01:P2.5,P2.4; 11:P3.2,P3.3
    I2C_S0 =0;
    I2CCFG = 0xe0;              //ʹI2Cģʽ
    I2CMSST = 0x00;
}

void Wait()
{
    while (!(I2CMSST & 0x40));
    I2CMSST &= ~0x40;
}

void Start()
{
    I2CMSCR = 0x01;                         //START
    Wait();
}

void SendData_iic(char dat)
{
    I2CTXD = dat;                           //дݵݻ
    I2CMSCR = 0x02;                         //SEND
    Wait();
}

void RecvACK()
{
    I2CMSCR = 0x03;                         //ͶACK
    Wait();
}

char RecvData()
{
    I2CMSCR = 0x04;                         //RECV
    Wait();
    return I2CRXD;
}

void SendACK()
{
    I2CMSST = 0x00;                         //ACKź
    I2CMSCR = 0x05;                         //ACK
    Wait();
}

void SendNAK()
{
    I2CMSST = 0x01;                         //NAKź
    I2CMSCR = 0x05;                         //ACK
    Wait();
}

void Stop()
{
    I2CMSCR = 0x06;                         //STOP
    Wait();
}

void WriteNbyte(unsigned char addr, unsigned char *p, unsigned char number)  /*  WordAddress,First Data Address,Byte lenth   */
{
    Start();                                //ʼ
    SendData_iic(SLAW);                         //豸ַ+д
    RecvACK();
    SendData_iic(addr);                         //ʹ洢ַ
    RecvACK();
    do
    {
        SendData_iic(*p++);
        RecvACK();
    }
    while(--number);
    Stop();                                 //ֹͣ
}

void ReadNbyte(unsigned char addr, unsigned char *p, unsigned char number)   /*  WordAddress,First Data Address,Byte lenth   */
{
    Start();                                //ʼ
    SendData_iic(SLAW);                         //豸ַ+д
    RecvACK();
    SendData_iic(addr);                         //ʹ洢ַ
    RecvACK();
    Start();                                //ʼ
    SendData_iic(SLAR);                         //豸ַ+
    RecvACK();
    do
    {
        *p = RecvData();
        p++;
        if(number != 1) SendACK();          //send ACK
    }
    while(--number);
    SendNAK();                              //send no ACK	
    Stop();                                 //ֹͣ
}

void Write_data(char address,float dat)
{
	WriteNbyte(address, (unsigned char)&dat, 4);
}

float Read_data(char address)
{
	float num = 0.0;
	ReadNbyte(address,(unsigned char)&num,4);
	return num;
}